<?php

/**
 * @file
 * TODO: description
 */

// ------------------------------------------------------------------
// Administration
// ------------------------------------------------------------------

/**
 * Settings form.
 */
function club_fb_settings_form() {
  $form['app'] = array(
    '#type' => 'fieldset',
    '#title' => t('Facebook application settings'),
    '#description' => t('To create a new Facebook application which you can use for your club, go to <a href="http://developers.facebook.com/get_started.php">this page</a>.')
  );
  $form['app']['club_fb_appid'] = array(
    '#type' => 'textfield',
    '#title' => t('Application ID'),
    '#default_value' => club_fb_appid(),
  );
  $form['app']['club_fb_apikey'] = array(
    '#type' => 'textfield',
    '#title' => t('API Key'),
    '#default_value' => club_fb_apikey(),
  );
  $form['app']['club_fb_secret'] = array(
    '#type' => 'textfield',
    '#title' => t('Secret'),
    '#default_value' => club_fb_secret(),
  );
  $form['page'] = array(
    '#type' => 'fieldset',
    '#title' => t('Facebook page'),
    '#description' => t('If you want to publish your content to Facebook, you need to create a <a href="http://www.facebook.com/advertising/?pages">Facebook Page</a> for your club.')
  );
  $form['page']['club_fb_pageid'] = array(
    '#type' => 'textfield',
    '#title' => t('Page ID'),
    '#default_value' => club_fb_pageid(),
    '#description' => t('The id of your club\'s Facebook page.')
  );
  $form['admin'] = array(
    '#type' => 'fieldset',
    '#title' => t('Page admin'),
    '#description' => t('To be able to perform certain operations, you need an admin of your Facebook page which will be used to publish the content. The content will be published in the name of the club, but the admin\'s account is used for the publishing.')
  );
  $form['admin']['club_fb_adminid'] = array(
    '#type' => 'textfield',
    '#title' => t('Admin user ID'),
    '#default_value' => club_fb_adminid(),
    '#description' => t('The Facebook user id of your club\'s Facebook page admin.')
  );
  
  

  if (club_fb_appid() && club_fb_apikey() && club_fb_secret() && club_fb_pageid()) {
    $facebook = club_fb_connect();

    // Wrong indentation level!
    try {
      
    //$facebook->api_client->admin_getAppProperties(array('application_name','callback_url','ip_list'));
    
    // Check page settings
    $permission = 'publish_stream';
    $granted = $facebook->api_client->users_hasAppPermission($permission, club_fb_pageid());
    if ($granted) {
      $message = t('Permission granted');
      $class = 'ok';
    }
    else {
      $message = ('Permission not granted.') . ' ' . l(t('Grant now!'), club_fb_permission_url($permission, TRUE));
      $class = 'warning';
    }
    $form['page']['permissions'] = array(
      '#value' => '<div><strong>' . t('Permissions') . '</strong></div>',
    );
    $form['page']['perm_' . $permission] = array(
      '#value' => '<div class="' . $class . '"><strong>' . $permission . '</strong>: ' . $message . '</div>'
    );
    
    // Check page admin settings
    if (club_fb_adminid()) {
      $fbuid = club_fb_adminid(); 
      $info = $facebook->api_client->users_getInfo($fbuid, 'last_name, first_name');
      $info = $info[0];
      $form['admin']['username'] = array(
        '#value' => '<div><strong>' . t('Name') . '</strong>: ' . $info['first_name'] . ' ' . $info['last_name'] . '</div>',
      );
      $session = db_fetch_object(db_query("SELECT * FROM {club_fb_user} WHERE fbuid='%s'", $fbuid));
      if ((!$session) || (($session->session_expire) && ($session->session_expire < time()))) {
        $url = url($facebook->get_login_url($_SERVER['REQUEST_URI'], $facebook->in_frame()));
        $message = t('Not logged in.') . ' ' . l(t('Log in now!'), $url);
        $class = 'warning';
        $logged_in = FALSE;
      }
      else {
        $facebook->set_user(club_fb_adminid(), $session->session_key);
        $message = t('Logged in.');
        $class = 'ok';
        $logged_in = TRUE;
      }
      $form['admin']['login'] = array(
        '#value' => '<div class="' . $class . '"><strong>' . t('Login status') . '</strong>: ' . $message . '</div>',
      );
      
      if ($logged_in) {
        if ($session->session_expire) {
          $url = url($facebook->get_login_url($_SERVER['REQUEST_URI'], $facebook->in_frame()));
          $message = t('Session may expire. Grant offline access and log in again.') . ' ' . l(t('Log in again!'), $url);
          $class = 'warning';
        }
        else {
          $message = t('Unlimited session');
          $class = 'ok';
        }
        $form['admin']['session'] = array(
          '#value' => '<div class="' . $class . '"><strong>' . t('Session status') . '</strong>: ' . $message . '</div>',
        );
        
        $is_admin = $facebook->api_client->pages_isAdmin(club_fb_pageid(), $fbuid);
        if ($is_admin) {
          $message = t('User is page admin.');
          $class = 'ok';
        }
        else {
          $message = t('User is not page admin. Either select a page admin or make this user an admin of the page.');
          $class = 'warning';
        }
        $form['admin']['pageadmin'] = array(
          '#value' => '<div class="' . $class . '"><strong>' . t('Page admin') . '</strong>: ' . $message . '</div>',
        );
      }
      
            
      $form['admin']['permissions'] = array(
        '#value' => '<div><strong>' . t('Permissions') . '</strong></div>',
      );
      $extended_permissions = array('publish_stream', 'read_stream', 'offline_access', 'create_event');
      foreach($extended_permissions as $permission) {
        $granted = $facebook->api_client->users_hasAppPermission($permission, $fbuid);
        if ($granted) {
          $message = t('Permission granted.');
          $class = 'ok';
        }
        else {
          $message = t('Permission not granted.');
          if ($logged_in) {
            $message .=  ' ' . l(t('Grant now!'), club_fb_permission_url($permission));
          }
          $class = 'warning';
        }
        $form['admin']['perm_' . $permission] = array(
          '#value' => '<div class="' . $class . '"><strong>' . $permission . '</strong>: ' . $message . '</div>'
        );
      }
    }

    // Wrong indentation level!
    }
    catch (FacebookRestClientException $e) {
      $form['api_error'] = array(
        '#value' => '<div>' . 'Facebook API Error: ' . $e->getCode() . ' - ' . $e->getMessage() . '</div>',
      );
    }
    
  }

  $form['types'] = array(
    '#type' => 'fieldset',
    '#title' => t('Content types'),
  );
  $form['types']['club_fb_contenttypes'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Content types'),
    '#default_value' => club_fb_contenttypes(),
    '#options' => node_get_types('names'),
    '#description' => t('Select the content types that can be published.')
  );
  $form['types']['club_fb_showlink'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show publish link for nodes'),
    '#default_value' => club_fb_showlink(),
  );
/*  
  $form['types']['club_fb_showineditform'] = array(
    '#type' => 'checkbox',
    '#title' => t('Show publish box in node edit form'),
    '#default_value' => club_fb_showineditform(),
  );
*/
  $form['events'] = array(
    '#type' => 'fieldset',
    '#title' => t('Events'),
  );
/*
  $form['events']['club_fb_eventtypes'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Content types'),
//    '#default_value' => club_fb_eventtypes(),
    '#options' => node_get_types('names'),
    '#description' => t('Select the content types that can be published as event.')
  );
*/
  return system_settings_form($form);
}

