<?php

/**
 * Field handler to present a link node edit.
 */
class views_handler_field_node_link_edit_as_icon extends views_handler_field_node_link {
  function construct() {
    parent::construct();
    $this->additional_fields['uid'] = 'uid';
    $this->additional_fields['type'] = 'type';
    $this->additional_fields['format'] = array('table' => 'node_revisions', 'field' => 'format');
  }

  function render($values) {
    // ensure user has access to edit this node.
    $node = new stdClass();
    $node->nid = $values->{$this->aliases['nid']};
    $node->uid = $values->{$this->aliases['uid']};
    $node->type = $values->{$this->aliases['type']};
    $node->format = $values->{$this->aliases['format']};
    $node->status = 1; // unpublished nodes ignore access control
    if (!node_access('update', $node)) {
      return;
    }
    
    $image_path = drupal_get_path('module', 'club_person') . '/images/icons/application_edit.png';

    $text = !empty($this->options['text']) ? $this->options['text'] : t('edit');
    return l('<img src="' . url($image_path) .'"/>', "node/$node->nid/edit", array('query' => drupal_get_destination(), 'html' => TRUE));
  }
}

